from base import ConverterBase

import os, tempfile, re

# wv config file (wvZope.xml) is in same directory as this module.
WV_CONFIG = os.path.join(
	os.getcwd(), os.path.dirname(__file__), 'wvZope.xml')

mime_type = 'application/msword'

class Converter(ConverterBase):
	def __init__(self, name, data):
		ConverterBase.__init__(self, name, data)

		self.tmpdir = tempfile.mktemp()
		os.mkdir('%s' % self.tmpdir)

		fd = open("%s/%s.doc" % (self.tmpdir, self.name), "w")
		fd.write(self.data)
		fd.close()

		self._convert()

	def __del__(self):
		for fn in os.listdir("%s" % self.tmpdir):
			os.remove("%s/%s" % (self.tmpdir, fn))
		os.rmdir("%s" % self.tmpdir)

	def _convert(self):
		cmd = "cd '%s' && wvWare -x %s '%s.doc' > '%s.html' 2> /dev/null" \
			% (self.tmpdir, WV_CONFIG, self.name, self.name)
		os.system(cmd)
		cmd = "cd '%s' && wvText '%s.doc' '%s.txt' 2> /dev/null" \
			% (self.tmpdir, self.name, self.name)
		os.system(cmd)

	#
	# Accessors to get results.
	#
	def getText(self):
		return open("%s/%s.txt" % (self.tmpdir, self.name)).read()

	def getHtml(self):
		data = open("%s/%s.html" % (self.tmpdir, self.name)).read()
		# XXX: how can I be sure that text is utf-8 encoded ???
		try:
			data = unicode(data, 'utf-8')
			return data.encode('latin-1')
		except:
			return data

	def getImageNames(self):
		image_names = []
		for fn in os.listdir(self.tmpdir):
			m = re.match("^.+\.(?P<ext>.+)$", fn)
			if m and m.group(1) in ('png', 'jpg', 'gif', 'wmz', 'wmf'):
				image_names.append(fn)
		return image_names

	def getImage(self, image_name):
		return open("%s/%s" % (self.tmpdir, image_name)).read()

def acceptFile(file):
	tempname = tempfile.mktemp()
	open(tempname, 'wc').write(file)
	res = os.popen('file %s' % tempname).read()
	os.unlink('%s' % tempname)
	#
	# XXX: will match any Office document (.ppt, .xls), not only Word !
	# XXX: file returns 'Microsoft Office Document' for StarOffice documents!
	#
	if re.search('Microsoft Office Document', res) or\
		re.search('Microsoft Word document data', res):
		return 1
	return 0

def acceptMimeType(mime_type):
	return mime_type == 'application/msword'

# vim:ts=2
