from base import ConverterBase

import os, tempfile, re

mime_type = 'application/pdf' # XXX: check this

class Converter(ConverterBase):
	def __init__(self, name, data):
		ConverterBase.__init__(self, name, data)

		self.tmpdir = tempfile.mktemp()
		os.mkdir('%s' % self.tmpdir)

		fd = open("%s/%s.pdf" % (self.tmpdir, self.name), "w")
		fd.write(self.data)
		fd.close()

		self._convert()

	def __del__(self):
		for fn in os.listdir("%s" % self.tmpdir):
			os.remove("%s/%s" % (self.tmpdir, fn))
		os.rmdir("%s" % self.tmpdir)

	def _convert(self):
		cmd = "cd '%s' && pdftotext '%s.pdf' 2> /dev/null" \
			% (self.tmpdir, self.name)
		os.system(cmd)

	#
	# Accessors to get results.
	#
	def getText(self):
		return open("%s/%s.txt" % (self.tmpdir, self.name)).read()

	def getHtml(self):
		return '<pre>' + self.getText() + '</pre>'

	def getImageNames(self):
		return []

def acceptFile(file):
	tempname = tempfile.mktemp()
	open(tempname, 'wc').write(file)
	res = os.popen('file %s' % tempname).read()
	os.unlink('%s' % tempname)
	#
	# XXX: will match any Office document (.ppt, .xls), not only Word !
	# XXX: file returns 'Microsoft Office Document' for StarOffice documents!
	#
	if re.search('PDF document', res):
		return 1
	return 0

def acceptMimeType(mime_type):
	return mime_type == 'application/pdf'

# vim:ts=2
